
          ifnd MACROS_I_INCLUDED

MACROS_I_INCLUDED = 1

;-------- Program macros -------------------------------------------------------

          macro default
           ifnd \1
\1=\2
           endif
          endm

          macro extern
           if \#==0 || \#>8
            fail "illegal number of arguments"
           endif
           xdef \1
           if \#>=2
            xdef \2
           endif
           if \#>=3
            xdef \3
           endif
           if \#>=4
            xdef \4
           endif
           if \#>=5
            xdef \5
           endif
           if \#>=6
            xdef \6
           endif
           if \#>=7
            xdef \7
           endif
           if \#==8
            xdef \8
           endif
          endm

          macro waitblt
           move.w   #$8400,$dff096
.\@        btst     #6,$dff002
           bne.b    .\@
           move.w   #$400,$dff096
          endm

          macro waitline
           if \#==1
            move.l  d0,-(sp)
.\@         move.l  $dff004,d0
            lsr.l   #1,d0
            lsr.w   #7,d0
            cmp.w   \1,d0
            bne.b   .\@
            move.l  (sp)+,d0
           else
.\@         move.l  $dff004,\2
            lsr.l   #1,\2
            lsr.w   #7,\2
            cmp.w   \1,\2
            bne.b   .\@
           endif
          endm

          ; only works with display-modes that have 257-512 scanlines
          macro waitframe
.1\@       btst     #0,$dff005
           beq.b    .1\@
.2\@       btst     #0,$dff005
           bne.b    .2\@
          endm

          macro testjoyb
           btst     #7,$bfe001
          endm

          macro testlmb
           btst     #6,$bfe001
          endm

          macro testrmb
           btst     #2,$dff016
          endm

          macro stdcall
           if \#>8 || \#==0
            fail "illegal number of arguments"
           endif
           if \#==8
            move.l  \8,-(sp)
           endif
           if \#>=7
            move.l  \7,-(sp)
           endif
           if \#>=6
            move.l  \6,-(sp)
           endif
           if \#>=5
            move.l  \5,-(sp)
           endif
           if \#>=4
            move.l  \4,-(sp)
           endif
           if \#>=3
            move.l  \3,-(sp)
           endif
           if \#>=2
            move.l  \2,-(sp)
           endif
           jsr      _\1
           add      #4*(\#-1),sp
          endm

          macro syscall
           if \#==2
            xref \2
            move.l  \2,a6
           endif
           jsr      (LVO\1,a6)
          endm

          macro execall
           move.l   4.w,a6
           jsr      (LVO\1,a6)
          endm

          macro doscall
           xref _DOSBase
           move.l   _DOSBase,a6
           jsr      (LVO\1,a6)
          endm

          macro intcall
           xref _IntuitionBase
           move.l   _IntuitionBase,a6
           jsr      (LVO\1,a6)
          endm

          macro gfxcall
           xref _GfxBase
           move.l   _GfxBase,a6
           jsr      (LVO\1,a6)
          endm

          macro push
           opt om+
           movem.l  \1,-(sp)
           opt om-
          endm

          macro pop
           opt om+
           movem.l  (sp)+,\1
           opt om-
          endm

          macro pushw
           opt om+
           movem.w  \1,-(sp)
           opt om-
          endm

          macro popw
           opt om+
           movem.w  (sp)+,\1
           opt om-
          endm


;-------- Conditional macros ---------------------------------------------------

          macro if_equal
           bne      .\@!
          endm

          macro if_not_equal
           beq      .\@!
          endm

          macro if_null
           bne      .\@!
          endm

          macro if_not_null
           beq      .\@!
          endm

          macro if_null_pointer
           bne      .\@!
          endm
 
          macro if_valid_pointer
           beq      .\@!
          endm

          macro if_false
           bne      .\@!
          endm

          macro if_non_zero
           beq      .\@!
          endm

          macro if_not_zero
           beq      .\@!
          endm

          macro if_true
           beq      .\@!
          endm

          macro if_negative
           bpl      .\@!
          endm

          macro if_neg
           bpl      .\@!
          endm

          macro if_positive
           bmi      .\@!
          endm

          macro if_pos
           bmi      .\@!
          endm

          macro if_carry
           bcc      .\@!
          endm

          macro if_carry_set
           bcc      .\@!
          endm

          macro if_carry_clear
           bcs      .\@!
          endm

          macro if_carry_cleared
           bcs      .\@!
          endm

          macro if_no_carry
           bcs      .\@!
          endm

          macro if_set
           beq      .\@!
          endm

          macro if_one
           beq      .\@!
          endm

          macro if_not_clear
           beq      .\@!
          endm

          macro if_not_cleared
           beq      .\@!
          endm

          macro if_not_set
           bne      .\@!
          endm

          macro if_zero
           bne      .\@!
          endm

          macro if_clear
           bne      .\@!
          endm

          macro if_cleared
           bne      .\@!
          endm

          macro if_lower
           bls      .\@!
          endm

          macro if_lower_than
           bls      .\@!
          endm

          macro if_lower_or_same
           blo      .\@!
          endm

          macro if_higher
           bhs      .\@!
          endm

          macro if_higher_than
           bhs      .\@!
          endm

          macro if_higher_than_zero
           bhs      .\@!
          endm

          macro if_higher_or_same
           bhi      .\@!
          endm

          macro if_less
           ble      .\@!
          endm

          macro if_less_than
           ble      .\@!
          endm

          macro if_less_than_zero
           ble      .\@!
          endm

          macro if_less_or_equal
           blt      .\@!
          endm
          
          macro if_greater
           bge      .\@!
          endm

          macro if_greater_than
           bge      .\@!
          endm

          macro if_greater_than_zero
           bge      .\@!
          endm

          macro if_greater_or_equal
           bgt      .\@!
          endm
 
          macro else_if
           bra      .\@?
.\@@
          endm

          macro end_if
.\@@
          endm


;-------- Copper macros --------------------------------------------------------

          ; cmove helper
          macro cmove_
           if ((\2)>=$200 && (\2)<$dff000) || (\2)&1==1 || (\2)<0 || (\2)>=$dff200
            printt "cmove address error in expression: \2"
            printv \2
            fail
           endif
           dc.w (\2)&$1fe,\1
          endm

          macro cmove
           if \#&1==1
            fail "illegal number of arguments"
           endif

           cmove_ \1,\2
           if \#>=4
            cmove_ \3,\4
            if \#>=6
             cmove_ \5,\6
             if \#>=8
              cmove_ \7,\8
             endif
            endif
           endif
          endm

          macro cend
           dc.l -2
          endm

          macro cjump1
           dc.w $88,0
          endm

          macro cjump2
           dc.w $8a,0
          endm

          macro cwaitnextseg
           dc.l $ffe1fffe
          endm

          macro cwaitv
           dc.b \1,1,$ff,0
          endm

          macro cwaith
           dc.w (\1)|1,$80fe
          endm

          macro cwaitb
           dc.w 1,0
          endm

          macro cwaitblt
           dc.w 1,0
          endm

          macro cwaitvh
           dc.b \1,(\2)|1,$ff,$fe
          endm

          macro cwaitvb
           dc.b \1,1,$7f,0
          endm

          macro cwaithb
           dc.w (\1)|1,$7e
          endm

          macro cwaitvhb
           dc.w (\1)|1,$7ffe
          endm

          macro cskipv
           dc.b \1,1,$ff,1
          endm

          macro cskiph
           dc.w (\1)|1,$80ff
          endm

          macro cskipb
           dc.w 1,1
          endm

          macro cskipblt
           dc.w 1,1
          endm

          macro cskipvh
           dc.b \1,(\2)|1,$ff,$ff
          endm

          macro cskipvb
           dc.b \1,1,$7f,1
          endm

          macro cskiphb
           dc.w (\1)|1,$ff
          endm

          macro cskipvhb
           dc.w (\1)|1,$7fff
          endm

          macro cno_op
           dc.w $1,$8000
          endm

;-------------------------------------------------------------------------------

          endif
